QwtPlotGrid Class Reference

A class which draws a coordinate grid. More...

`#include <qwt_plot_grid.h>`

Inheritance diagram for QwtPlotGrid:

## Public Member Functions

| QwtPlotGrid ()
| Enables major grid, disables minor grid.
virtual | ~QwtPlotGrid ()
| Destructor.
virtual int | rtti () const override
void | enableX (bool)
| Enable or disable vertical grid lines. More...
bool | xEnabled () const
void | enableY (bool)
| Enable or disable horizontal grid lines. More...
bool | yEnabled () const
void | enableXMin (bool)
| Enable or disable minor vertical grid lines. More...
bool | xMinEnabled () const
void | enableYMin (bool)
| Enable or disable minor horizontal grid lines. More...
bool | yMinEnabled () const
void | setXDiv (const QwtScaleDiv &)
const QwtScaleDiv & | xScaleDiv () const
void | setYDiv (const QwtScaleDiv &)
const QwtScaleDiv & | yScaleDiv () const
void | setPen (const QColor &, qreal width=0.0, Qt::PenStyle=Qt::SolidLine)
void | setPen (const QPen &)
void | setMajorPen (const QColor &, qreal width=0.0, Qt::PenStyle=Qt::SolidLine)
void | setMajorPen (const QPen &)
const QPen & | majorPen () const
void | setMinorPen (const QColor &, qreal width=0.0, Qt::PenStyle=Qt::SolidLine)
void | setMinorPen (const QPen &)
const QPen & | minorPen () const
virtual void | draw (QPainter *, const QwtScaleMap &xMap, const QwtScaleMap &yMap, const QRectF &canvasRect) const override
| Draw the grid. More...
virtual void | updateScaleDiv (const QwtScaleDiv &xScaleDiv, const QwtScaleDiv &yScaleDiv) override
Public Member Functions inherited from QwtPlotItem
| QwtPlotItem ()
| QwtPlotItem (const QString &title)
| QwtPlotItem (const QwtText &title)
virtual | ~QwtPlotItem ()
| Destroy the QwtPlotItem.
void | attach (QwtPlot *plot)
| Attach the item to a plot. More...
void | detach ()
| This method detaches a QwtPlotItem from any QwtPlot it has been associated with. More...
QwtPlot * | plot () const
| Return attached plot.
void | setTitle (const QString &title)
void | setTitle (const QwtText &title)
const QwtText & | title () const
void | setItemAttribute (ItemAttribute, bool on=true)
bool | testItemAttribute (ItemAttribute) const
void | setItemInterest (ItemInterest, bool on=true)
bool | testItemInterest (ItemInterest) const
void | setRenderHint (RenderHint, bool on=true)
bool | testRenderHint (RenderHint) const
void | setRenderThreadCount (uint numThreads)
uint | renderThreadCount () const
void | setLegendIconSize (const QSize &)
QSize | legendIconSize () const
double | z () const
void | setZ (double z)
| Set the z value. More...
void | show ()
| Show the item.
void | hide ()
| Hide the item.
virtual void | setVisible (bool)
bool | isVisible () const
void | setAxes (QwtAxisId xAxis, QwtAxisId yAxis)
void | setXAxis (QwtAxisId)
QwtAxisId | xAxis () const
| Return xAxis.
void | setYAxis (QwtAxisId)
QwtAxisId | yAxis () const
| Return yAxis.
virtual void | itemChanged ()
virtual void | legendChanged ()
virtual QRectF | boundingRect () const
virtual void | getCanvasMarginHint (const QwtScaleMap &xMap, const QwtScaleMap &yMap, const QRectF &canvasRect, double &left, double &top, double &right, double &bottom) const
| Calculate a hint for the canvas margin. More...
virtual void | updateLegend (const QwtPlotItem *, const QList< QwtLegendData > &)
| Update the item to changes of the legend info. More...
QRectF | scaleRect (const QwtScaleMap &, const QwtScaleMap &) const
| Calculate the bounding scale rectangle of 2 maps. More...
QRectF | paintRect (const QwtScaleMap &, const QwtScaleMap &) const
| Calculate the bounding paint rectangle of 2 maps. More...
virtual QList< QwtLegendData > | legendData () const
| Return all information, that is needed to represent the item on the legend. More...
virtual QwtGraphic | legendIcon (int index, const QSizeF &) const

## Additional Inherited Members

Public Types inherited from QwtPlotItem

enum

RttiValues {
Rtti_PlotItem = 0 , Rtti_PlotGrid , Rtti_PlotScale , Rtti_PlotLegend ,
Rtti_PlotMarker , Rtti_PlotCurve , Rtti_PlotSpectroCurve , Rtti_PlotIntervalCurve ,
Rtti_PlotHistogram , Rtti_PlotSpectrogram , Rtti_PlotGraphic , Rtti_PlotTradingCurve ,
Rtti_PlotBarChart , Rtti_PlotMultiBarChart , Rtti_PlotShape , Rtti_PlotTextLabel ,
Rtti_PlotZone , Rtti_PlotVectorField , Rtti_PlotUserItem = 1000
}

| Runtime type information. More...
enum | ItemAttribute { Legend = 0x01 , AutoScale = 0x02 , Margins = 0x04 }
| Plot Item Attributes. More...
enum | ItemInterest { ScaleInterest = 0x01 , LegendInterest = 0x02 }
| Plot Item Interests. More...
enum | RenderHint { RenderAntialiased = 0x1 }
| Render hints. More...
typedef QFlags< ItemAttribute > | ItemAttributes
typedef QFlags< ItemInterest > | ItemInterests
typedef QFlags< RenderHint > | RenderHints
Protected Member Functions inherited from QwtPlotItem
QwtGraphic | defaultIcon (const QBrush &, const QSizeF &) const
| Return a default icon from a brush. More...

## Detailed Description

A class which draws a coordinate grid.

The QwtPlotGrid class can be used to draw a coordinate grid. A coordinate grid consists of major and minor vertical and horizontal grid lines. The locations of the grid lines are determined by the X and Y scale divisions which can be assigned with setXDiv() and setYDiv(). The draw() member draws the grid within a bounding rectangle.

Definition at line 33 of file qwt_plot_grid.h.

## Member Function Documentation

## draw()

void QwtPlotGrid::draw | ( | QPainter * | painter,
|  | const QwtScaleMap & | xMap,
|  | const QwtScaleMap & | yMap,
|  | const QRectF & | canvasRect
| ) |  | const

override virtual

Draw the grid.

The grid is drawn into the bounding rectangle such that grid lines begin and end at the rectangle's borders. The X and Y maps are used to map the scale divisions into the drawing region screen.

Parameters

  painter | Painter
  xMap | X axis map
  yMap | Y axis
  canvasRect | Contents rectangle of the plot canvas

Implements QwtPlotItem.

Definition at line 282 of file qwt_plot_grid.cpp.

## enableX()

void QwtPlotGrid::enableX | ( | bool | on | ) |

Enable or disable vertical grid lines.

Parameters

  on | Enable (true) or disable

See also
  Minor grid lines can be enabled or disabled with enableXMin()

Definition at line 76 of file qwt_plot_grid.cpp.

## enableXMin()

void QwtPlotGrid::enableXMin | ( | bool | on | ) |

Enable or disable minor vertical grid lines.

Parameters

  on | Enable (true) or disable

See also
  enableX()

Definition at line 108 of file qwt_plot_grid.cpp.

## enableY()

void QwtPlotGrid::enableY | ( | bool | on | ) |

Enable or disable horizontal grid lines.

Parameters

  on | Enable (true) or disable

See also
  Minor grid lines can be enabled or disabled with enableYMin()

Definition at line 92 of file qwt_plot_grid.cpp.

## enableYMin()

void QwtPlotGrid::enableYMin | ( | bool | on | ) |

Enable or disable minor horizontal grid lines.

Parameters

  on | Enable (true) or disable

See also
  enableY()

Definition at line 124 of file qwt_plot_grid.cpp.

## majorPen()

const QPen & QwtPlotGrid::majorPen | ( |  | ) | const

Returns
  the pen for the major grid lines

See also
  setMajorPen(), setMinorPen(), setPen()

Definition at line 367 of file qwt_plot_grid.cpp.

## minorPen()

const QPen & QwtPlotGrid::minorPen | ( |  | ) | const

Returns
  the pen for the minor grid lines

See also
  setMinorPen(), setMajorPen(), setPen()

Definition at line 376 of file qwt_plot_grid.cpp.

## rtti()

int QwtPlotGrid::rtti | ( |  | ) | const

override virtual

Returns
  QwtPlotItem::Rtti_PlotGrid

Reimplemented from QwtPlotItem.

Definition at line 64 of file qwt_plot_grid.cpp.

## setMajorPen() [1/2]

void QwtPlotGrid::setMajorPen | ( | const QColor & | color,
|  | qreal | width = `0.0`,
|  | Qt::PenStyle | style = `Qt::SolidLine`
| ) |  |

Build and assign a pen for both major grid lines

In Qt5 the default pen width is 1.0 ( 0.0 in Qt4 ) what makes it non cosmetic ( see QPen::isCosmetic() ). This method has been introduced to hide this incompatibility.

Parameters

  color | Pen color
  width | Pen width
  style | Pen style

See also
  pen(), brush()

Definition at line 212 of file qwt_plot_grid.cpp.

## setMajorPen() [2/2]

void QwtPlotGrid::setMajorPen | ( | const QPen & | pen | ) |

Assign a pen for the major grid lines

Parameters

  pen | Pen

See also
  majorPen(), setMinorPen(), setPen()

Definition at line 223 of file qwt_plot_grid.cpp.

## setMinorPen() [1/2]

void QwtPlotGrid::setMinorPen | ( | const QColor & | color,
|  | qreal | width = `0.0`,
|  | Qt::PenStyle | style = `Qt::SolidLine`
| ) |  |

Build and assign a pen for the minor grid lines

In Qt5 the default pen width is 1.0 ( 0.0 in Qt4 ) what makes it non cosmetic ( see QPen::isCosmetic() ). This method has been introduced to hide this incompatibility.

Parameters

  color | Pen color
  width | Pen width
  style | Pen style

See also
  pen(), brush()

Definition at line 247 of file qwt_plot_grid.cpp.

## setMinorPen() [2/2]

void QwtPlotGrid::setMinorPen | ( | const QPen & | pen | ) |

Assign a pen for the minor grid lines

Parameters

  pen | Pen

See also
  minorPen(), setMajorPen(), setPen()

Definition at line 258 of file qwt_plot_grid.cpp.

## setPen() [1/2]

void QwtPlotGrid::setPen | ( | const QColor & | color,
|  | qreal | width = `0.0`,
|  | Qt::PenStyle | style = `Qt::SolidLine`
| ) |  |

Build and assign a pen for both major and minor grid lines

In Qt5 the default pen width is 1.0 ( 0.0 in Qt4 ) what makes it non cosmetic ( see QPen::isCosmetic() ). This method has been introduced to hide this incompatibility.

Parameters

  color | Pen color
  width | Pen width
  style | Pen style

See also
  pen(), brush()

Definition at line 176 of file qwt_plot_grid.cpp.

## setPen() [2/2]

void QwtPlotGrid::setPen | ( | const QPen & | pen | ) |

Assign a pen for both major and minor grid lines

Parameters

  pen | Pen

See also
  setMajorPen(), setMinorPen()

Definition at line 187 of file qwt_plot_grid.cpp.

## setXDiv()

void QwtPlotGrid::setXDiv | ( | const QwtScaleDiv & | scaleDiv | ) |

Assign an x axis scale division

Parameters

  scaleDiv | Scale division

Definition at line 140 of file qwt_plot_grid.cpp.

## setYDiv()

void QwtPlotGrid::setYDiv | ( | const QwtScaleDiv & | scaleDiv | ) |

Assign a y axis division

Parameters

  scaleDiv | Scale division

Definition at line 154 of file qwt_plot_grid.cpp.

## updateScaleDiv()

void QwtPlotGrid::updateScaleDiv | ( | const QwtScaleDiv & | xScaleDiv,
|  | const QwtScaleDiv & | yScaleDiv
| ) |  |

override virtual

Update the grid to changes of the axes scale division

Parameters

  xScaleDiv | Scale division of the x-axis
  yScaleDiv | Scale division of the y-axis

See also
  QwtPlot::updateAxes()

Reimplemented from QwtPlotItem.

Definition at line 438 of file qwt_plot_grid.cpp.

## xEnabled()

bool QwtPlotGrid::xEnabled | ( |  | ) | const

Returns
  true if vertical grid lines are enabled

See also
  enableX()

Definition at line 385 of file qwt_plot_grid.cpp.

## xMinEnabled()

bool QwtPlotGrid::xMinEnabled | ( |  | ) | const

Returns
  true if minor vertical grid lines are enabled

See also
  enableXMin()

Definition at line 394 of file qwt_plot_grid.cpp.

## xScaleDiv()

const QwtScaleDiv & QwtPlotGrid::xScaleDiv | ( |  | ) | const

Returns
  the scale division of the x axis

Definition at line 419 of file qwt_plot_grid.cpp.

## yEnabled()

bool QwtPlotGrid::yEnabled | ( |  | ) | const

Returns
  true if horizontal grid lines are enabled

See also
  enableY()

Definition at line 403 of file qwt_plot_grid.cpp.

## yMinEnabled()

bool QwtPlotGrid::yMinEnabled | ( |  | ) | const

Returns
  true if minor horizontal grid lines are enabled

See also
  enableYMin()

Definition at line 412 of file qwt_plot_grid.cpp.

## yScaleDiv()

const QwtScaleDiv & QwtPlotGrid::yScaleDiv | ( |  | ) | const

Returns
  the scale division of the y axis

Definition at line 425 of file qwt_plot_grid.cpp.